/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "ticket.ec"
/*
 * Scheduling ticket.
 * Copyright (C) 2008 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2scheduler/ticket.h"

#include "configuration.h"
#include "rts2db/sqlerror.h"

using namespace rts2sched;

Ticket::Ticket (int _schedTicketId)
{
	ticketId = _schedTicketId;
	target = NULL;
}

Ticket::Ticket (int _schedTicketId, rts2db::Target *_target, int _accountId, unsigned int _obs_num, double _sched_from, double _sched_to, double _sched_interval_min, double _sched_interval_max)
{
	ticketId = _schedTicketId;
	target = _target;
	accountId = _accountId;
	obs_num = _obs_num;
	sched_from = _sched_from;
	sched_to = _sched_to;
	sched_interval_min = _sched_interval_min;
	sched_interval_max = _sched_interval_max;
}

void Ticket::load ()
{
	/* exec sql begin declare section */
		 
		 
		 
		  
		 
		 
		 
		 
		 
		 
		 
		 
		 
	
#line 48 "ticket.ec"
 int d_schedticket_id ;
 
#line 49 "ticket.ec"
 int d_tar_id ;
 
#line 50 "ticket.ec"
 int d_account_id ;
 
#line 51 "ticket.ec"
 unsigned int d_obs_num ;
 
#line 52 "ticket.ec"
 int d_obs_num_ind ;
 
#line 53 "ticket.ec"
 long d_sched_from ;
 
#line 54 "ticket.ec"
 int d_sched_from_ind ;
 
#line 55 "ticket.ec"
 long d_sched_to ;
 
#line 56 "ticket.ec"
 int d_sched_to_ind ;
 
#line 57 "ticket.ec"
 double d_sched_interval_min ;
 
#line 58 "ticket.ec"
 int d_sched_interval_min_ind ;
 
#line 59 "ticket.ec"
 double d_sched_interval_max ;
 
#line 60 "ticket.ec"
 int d_sched_interval_max_ind ;
/* exec sql end declare section */
#line 61 "ticket.ec"


	d_schedticket_id = ticketId;

	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select tar_id , account_id , obs_num , extract ( EPOCH from sched_from ) , extract ( EPOCH from sched_to ) , extract ( EPOCH from sched_interval_min ) , extract ( EPOCH from sched_interval_max ) from tickets where schedticket_id = $1 ", 
	ECPGt_int,&(d_schedticket_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_account_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(d_obs_num),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_int,&(d_obs_num_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_long,&(d_sched_from),(long)1,(long)1,sizeof(long), 
	ECPGt_int,&(d_sched_from_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_long,&(d_sched_to),(long)1,(long)1,sizeof(long), 
	ECPGt_int,&(d_sched_to_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_sched_interval_min),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_sched_interval_min_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_sched_interval_max),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_sched_interval_max_ind),(long)1,(long)1,sizeof(int), ECPGt_EORT);}
#line 84 "ticket.ec"

	if (sqlca.sqlcode)
		throw rts2db::SqlError ();

	target = createTarget (d_tar_id, rts2core::Configuration::instance ()->getObserver ());
	if (target == NULL)
		throw rts2db::SqlError ();

	accountId = d_account_id;

	if (d_obs_num_ind < 0)
		obs_num = UINT_MAX;
	else
		obs_num = d_obs_num;

	if (d_sched_from_ind < 0)
		sched_from = rts2_nan ("f");
	else
		sched_from = ln_get_julian_from_timet (&d_sched_from);

	if (d_sched_to_ind < 0)
		sched_to = rts2_nan ("f");
	else
		sched_to = ln_get_julian_from_timet (&d_sched_to);

	if (d_sched_interval_min_ind < 0)
		sched_interval_min = -1;
	else
		sched_interval_min = d_sched_interval_min;

	if (d_sched_interval_max_ind < 0)
		sched_interval_max = -1;
	else
		sched_interval_max = d_sched_interval_max;
}

bool Ticket::violateSchedule (double _from, double _to)
{
	if (isnan (sched_from))
	{
		if (isnan (sched_to))
			return false;
		return _to > sched_to;
	}
	if (isnan (sched_to))
	{
		return _from < sched_from;
	}
	return (_from < sched_from) || (_to > sched_to);
}
