/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "ticketset.ec"
/*
 * Set of scheduling tickets.
 * Copyright (C) 2008 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "rts2scheduler/ticketset.h"
#include "rts2db/sqlerror.h"

using namespace rts2sched;

TicketSet::TicketSet (): std::map <int, Ticket *> ()
{
}


TicketSet::~TicketSet ()
{
	for (TicketSet::iterator iter = begin (); iter != end (); iter++)
		delete (*iter).second;
	
	clear ();
}


void
TicketSet::load (rts2db::TargetSet *tarSet)
{
	/* exec sql begin declare section */
	 
	 
	 
	  
	 
	 
	 
	 
	 
	 
	 
	 
	 
	
#line 43 "ticketset.ec"
 int d_schedticket_id ;
 
#line 44 "ticketset.ec"
 int d_tar_id ;
 
#line 45 "ticketset.ec"
 int d_account_id ;
 
#line 46 "ticketset.ec"
 unsigned int d_obs_num ;
 
#line 47 "ticketset.ec"
 int d_obs_num_ind ;
 
#line 48 "ticketset.ec"
 long d_sched_from ;
 
#line 49 "ticketset.ec"
 int d_sched_from_ind ;
 
#line 50 "ticketset.ec"
 long d_sched_to ;
 
#line 51 "ticketset.ec"
 int d_sched_to_ind ;
 
#line 52 "ticketset.ec"
 double d_sched_interval_min ;
 
#line 53 "ticketset.ec"
 int d_sched_interval_min_ind ;
 
#line 54 "ticketset.ec"
 double d_sched_interval_max ;
 
#line 55 "ticketset.ec"
 int d_sched_interval_max_ind ;
/* exec sql end declare section */
#line 56 "ticketset.ec"


	double sched_from, sched_to;

	/* declare cur_tickets cursor for select schedticket_id , tar_id , account_id , obs_num , extract ( EPOCH from sched_from ) , extract ( EPOCH from sched_to ) , extract ( EPOCH from sched_interval_min ) , extract ( EPOCH from sched_interval_max ) from tickets where ( ( obs_num is null ) or ( obs_num > 0 ) ) */
#line 72 "ticketset.ec"


	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cur_tickets cursor for select schedticket_id , tar_id , account_id , obs_num , extract ( EPOCH from sched_from ) , extract ( EPOCH from sched_to ) , extract ( EPOCH from sched_interval_min ) , extract ( EPOCH from sched_interval_max ) from tickets where ( ( obs_num is null ) or ( obs_num > 0 ) )", ECPGt_EOIT, ECPGt_EORT);}
#line 74 "ticketset.ec"

	if (sqlca.sqlcode)
		throw rts2db::SqlError();
	
	while (true)
	{
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cur_tickets", ECPGt_EOIT, 
	ECPGt_int,&(d_schedticket_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_tar_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(d_account_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_unsigned_int,&(d_obs_num),(long)1,(long)1,sizeof(unsigned int), 
	ECPGt_int,&(d_obs_num_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_long,&(d_sched_from),(long)1,(long)1,sizeof(long), 
	ECPGt_int,&(d_sched_from_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_long,&(d_sched_to),(long)1,(long)1,sizeof(long), 
	ECPGt_int,&(d_sched_to_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_sched_interval_min),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_sched_interval_min_ind),(long)1,(long)1,sizeof(int), 
	ECPGt_double,&(d_sched_interval_max),(long)1,(long)1,sizeof(double), 
	ECPGt_int,&(d_sched_interval_max_ind),(long)1,(long)1,sizeof(int), ECPGt_EORT);}
#line 88 "ticketset.ec"


		if (sqlca.sqlcode == ECPG_NOT_FOUND)
			break;
		else if (sqlca.sqlcode)
		  	throw rts2db::SqlError ();

		if (d_obs_num_ind < 0)
		  	d_obs_num = UINT_MAX;

		if (d_sched_from_ind < 0)
			sched_from = rts2_nan ("f");
		else
			sched_from = ln_get_julian_from_timet (&d_sched_from);

		if (d_sched_to_ind < 0)
		  	sched_to = rts2_nan ("f");
		else
		  	sched_to = ln_get_julian_from_timet (&d_sched_to);

		if (d_sched_interval_min_ind < 0)
			d_sched_interval_min = -1;
		if (d_sched_interval_max_ind < 0)
		  	d_sched_interval_max = -1;

		(*this)[d_schedticket_id] = new Ticket (d_schedticket_id, tarSet->getTarget (d_tar_id),
			d_account_id, d_obs_num, sched_from, sched_to,
			d_sched_interval_min, d_sched_interval_max);
	}
}


void
TicketSet::constructFromObsSet (rts2db::TargetSet *tarSet, rts2db::ObservationSet &obsSet)
{
	int ticket_id = 1;
	std::map <int, int> tarObs = obsSet.getTargetObservations ();
	for (std::map <int, int>::iterator iter = tarObs.begin (); iter != tarObs.end (); iter++, ticket_id++)
	{
		(*this)[ticket_id] = new Ticket (ticket_id, tarSet->getTarget ((*iter).first),
			0, (*iter).second, rts2_nan ("f"), rts2_nan ("f"), -1, -1);
	}
}
